module Lib1 where

import Control.Monad
import Lib

data Result = Success | Failure
  deriving (Eq, Show)

class Testable prop where
  property :: prop -> Gen Result

instance Testable Bool where
  property True  = return Success
  property False = return Failure

quickCheck :: Testable prop => prop -> IO ()
quickCheck p = do
  res <- generateMany 100 $ property p
  putStrLn $ show res

class Arbitrary a where
  arbitrary :: Gen a

instance Arbitrary Int where
  arbitrary = chooseInt (-10,10)

instance (Show a, Arbitrary a, Testable b) => Testable (a -> b) where
  property f = do
    x <- arbitrary
    property $ f x

